Package org.eclipse.cdt.core.dom.ast

# Interface IType

All Superinterfaces:
  `Cloneable`

All Known Subinterfaces:
  `IArrayType`, `IBasicType`, `ICArrayType`, `ICBasicType`, `ICompositeType`, `ICPointerType`, `ICPPAliasTemplate`, `ICPPAliasTemplateInstance`, `ICPPBasicType`, `ICPPClassSpecialization`, `ICPPClassTemplate`, `ICPPClassTemplatePartialSpecialization`, `ICPPClassTemplatePartialSpecializationSpecialization`, `ICPPClassType`, `ICPPEnumeration`, `ICPPEnumerationSpecialization`, `ICPPFunctionType`, `ICPPParameterPackType`, `ICPPPointerToMemberType`, `ICPPReferenceType`, `ICPPTemplateTemplateParameter`, `ICPPTemplateTypeParameter`, `ICPPTypeSpecialization`, `ICPPUnaryTypeTransformation`, `ICQualifierType`, `IEnumeration`, `IFunctionType`, `IGPPBasicType`, `IGPPPointerToMemberType`, `IGPPPointerType`, `IGPPQualifierType`, `IPointerType`, `IProblemBinding`, `IProblemType`, `IQualifierType`, `ITypedef`

public interface IType extends Cloneable
Interface for all c- and c++ types.

Restriction:
  This interface is not intended to be implemented by clients.
Restriction:
  This interface is not intended to be extended by clients.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final IType[]`
`EMPTY_TYPE_ARRAY`
`static final ASTTypeMatcher`
`TYPE_MATCHER`

## Method Summary

Modifier and Type
Method
Description
`Object`
`clone()`
`boolean`
`isSameType(IType type)`
Test whether this type is the same as the given one.

## Field Details

### EMPTY_TYPE_ARRAY

static final IType[] EMPTY_TYPE_ARRAY

### TYPE_MATCHER

static final ASTTypeMatcher TYPE_MATCHER

## Method Details

### clone

Object clone()

### isSameType

boolean isSameType(IType type)
Test whether this type is the same as the given one. A typedef is considered to be the same type as it's target type. See `ICPPTemplateTemplateParameter.isSameType(IType)` or `ICPPTemplateTypeParameter.isSameType(IType)` for the semantics of comparing template parameters denoting types.

Parameters:
  `type` - can be `null`.